/****************************************************************************
 *                                                                          *
 *     Loki - Programs for genetic analysis of complex traits using MCMC    *
 *                                                                          *
 *             Simon Heath - University of Washington                       *
 *                                                                          *
 *                      August 1997                                         *
 *                                                                          *
 * loki_utils.c:                                                            *
 *                                                                          *
 * Utility routines for loki                                                *
 *                                                                          *
 ****************************************************************************/

#include <config.h>

#include <stdio.h>

#include "loki.h"

void print_orig_family(FILE *fptr,const int id,const int fg) 
{
	int fam;
	
	fam=id>0?id_array[id-1].fam_code:0;
	if(fg) {
		if(!fam) fputs("[*]:",fptr);
		else if(fam_recode.flag==ST_STRING) fprintf(fptr,"[%s]:",fam_recode.recode[fam-1].string);
		else fprintf(fptr,"[%d]:",fam_recode.recode[fam-1].value);
	} else {
		if(!fam) fputs("*",fptr);
		else if(fam_recode.flag==ST_STRING) fprintf(fptr,"%s",fam_recode.recode[fam-1].string);
		else fprintf(fptr,"%d ",fam_recode.recode[fam-1].value);
	}
}

void print_orig_id1(FILE *fptr,const int i)
{
	if(!i) fputc('*',fptr);
	else {
		if(id_recode.flag==ST_STRING) fprintf(fptr,"%s",id_recode.recode[i-1].string);
		else fprintf(fptr,"%d",id_recode.recode[i-1].value);
	}
}

void print_orig_id(FILE *fptr,const int i)
{
	if(family_id) print_orig_family(fptr,i,1);
	print_orig_id1(fptr,i);
}

void print_orig_triple(FILE *fptr,const int i)
{
	if(family_id) {
		print_orig_family(fptr,i,0);
		fputc(' ',fptr);
	}
	if(i)	{
		print_orig_id1(fptr,i);
		fputc(' ',fptr);
		print_orig_id1(fptr,id_array[i-1].sire);
		fputc(' ',fptr);
		print_orig_id1(fptr,id_array[i-1].dam);
	}
	else fputs("* * *",fptr);
}

void print_orig_allele_id(FILE *fptr,const int i)
{
	if(i>0) {
		print_orig_id(fptr,i);
		fputc('m',fptr);
	} else {
		print_orig_id(fptr,-i);
		fputc('p',fptr);
	}
}
