/****************************************************************************
 *                                                                          *
 *     Loki - Programs for genetic analysis of complex traits using MCMC    *
 *                                                                          *
 *             Simon Heath - University of Washington                       *
 *                                                                          *
 *                        August 1997                                       *
 *                                                                          *
 * peel_util.c:                                                             *
 *                                                                          *
 ****************************************************************************/

#include <config.h>

#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#include "shared_peel.h"

int num_bits(const int n_all)
{
	int nb;
	
	nb=(int)(log((double)n_all)/log(2.0));
	if((1<<nb)<n_all) nb++;
	return nb;
}

void free_peelseq(struct Peelseq_Head *pp)
{
	struct Simple_Element *simple_em;
	struct Complex_Element *complex_em;
	void *old_ptr=0;
	
	while(pp->type) {
		if(pp->type==PEEL_SIMPLE) {
			simple_em=pp->ptr.simple;
			if(old_ptr) free(old_ptr);
			pp= &simple_em->next;
			free(simple_em->off);
			old_ptr=(void *)simple_em;
		} else {
			complex_em=pp->ptr.complex;
			if(old_ptr) free(old_ptr);
			pp= &complex_em->next;
			free(complex_em->involved);
			old_ptr=(void *)complex_em;
		}
	}
	if(old_ptr) free(old_ptr);
}
